routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers as Controladores;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Auth:: routes(['register' => false]);

Route::get('/home', [Controladores\HomeController::class, 'index'])->name('home');

Route::resource('users', Controladores\UserController::class)->middleware('auth');
Route::resource('providers', Controladores\ProviderController::class)->middleware('auth');
Route::resource('productos', Controladores\ProductoController::class)->middleware('auth');
Route::resource('clientes', Controladores\ClienteController::class)->middleware('auth');
Route::resource('especie-mascotas', Controladores\EspecieMascotaController::class)->middleware('auth');
Route::resource('mascotas', Controladores\MascotaController::class)->middleware('auth');
Route::resource('servicios', Controladores\ServicioController::class)->middleware('auth');
Route::resource('ventas', Controladores\VentaController::class)->except(['store'])->middleware('auth');
Route::get('consultas/atencion',[Controladores\ConsultaController::class,'atencion'])->middleware('auth')->name('consultas.atencion');
Route::get('consultas/programacion',[Controladores\ConsultaController::class,'programacion'])->middleware('auth')->name('consultas.programacion');
Route::resource('consultas', Controladores\ConsultaController::class)->middleware('auth');
Route::get('consultas/{consulta}/editDetail',[Controladores\ConsultaController::class,'editDetail'])->middleware('auth')->name('consultas.editDetail');
Route::patch('consultas/{consulta}',[Controladores\ConsultaController::class,'saveDetail'])->middleware('auth')->name('consultas.saveDetail');

app/Models/Provider.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

/**
 * Class Provider
 *
 * @property $id
 * @property $nombre
 * @property $contacto
 * @property $correo
 * @property $numero
 * @property $direccion
 * @property $created_at
 * @property $updated_at
 *
 * @property Producto[] $productos
 * @package App
 * @mixin \Illuminate\Database\Eloquent\Builder
 */
class Provider extends Model
{
    
    static $rules = [
		'nombre' => 'required|string|min:4|max:100|unique:providers,nombre',
		'contacto' => 'required|string|min:4|max:100',
		'correo' => 'required|string|min:13|max:100|unique:providers,correo',
		'numero' => 'required|digits:9|unique:providers,numero',
		'direccion' => 'required|string|min:20|max:300',
    ];

    /**
     * Attributes that should be mass-assignable.
     *
     * @var array
     */
    protected $fillable = ['nombre','contacto','correo','numero','direccion'];


    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function productos()
    {
        return $this->hasMany('App\Models\Producto', 'id_proveedor', 'id');
    }
    

}

app/Http/Controllers/ProviderController.php
<?php

namespace App\Http\Controllers;

use App\Models\Provider;
use Illuminate\Http\Request;

/**
 * Class ProviderController
 * @package App\Http\Controllers
 */
class ProviderController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $providers = Provider::All();

        return view('provider.index', compact('providers'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $provider = new Provider();
        return view('provider.create', compact('provider'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        request()->validate(Provider::$rules);

        Provider::create($request->all());

        return redirect()->route('providers.index')
            ->with('success', 'Proveedor registrado correctamente');
    }

    /**
     * Display the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $provider = Provider::find($id);

        return view('provider.show', compact('provider'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $provider = Provider::find($id);

        return view('provider.edit', compact('provider'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request $request
     * @param  Provider $provider
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Provider $provider)
    {
        $updrules = [
            'nombre' => 'required|string|min:4|max:100|unique:providers,nombre,'.$provider->id,
            'correo'=> 'required|string|min:13|max:100|unique:providers,correo,'.$provider->id,
            'numero'=> 'required|digits:9|unique:providers,numero,'.$provider->id,
        ];

        request()->validate(array_replace(Provider::$rules,$updrules));

        $provider->update($request->all());

        return redirect()->route('providers.index')
            ->with('success', 'Se actualizaron los datos del proveedor');
    }

    /**
     * @param int $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws \Exception
     */
    public function destroy($id)
    {
        $provider = Provider::find($id)->delete();

        return redirect()->route('providers.index')
            ->with('success', 'Proveedor eliminado con éxito');
    }
}

resources/views/provider/create.blade.php
@extends('layouts.app')

@section('template_title')
    Registro de Proveedor
@endsection

@section('content')
    <section class="content container-fluid">
        <div class="row">
            <div class="col-md-12">

                @includeif('partials.errors')

                <div class="card card-default">
                    <div class="card-header">
                        <span class="card-title">Crear Proveedor</span>
                    </div>
                    <div class="card-body">
                        <form method="POST" action="{{ route('providers.store') }}"  role="form" enctype="multipart/form-data">
                            @csrf

                            @include('provider.form')

                        </form>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection

resources/views/provider/edit.blade.php
@extends('layouts.app')

@section('template_title')
    Actualizar Proveedor
@endsection

@section('content')
    <section class="content container-fluid">
        <div class="">
            <div class="col-md-12">

                @includeif('partials.errors')

                <div class="card card-default">
                    <div class="card-header">
                        <span class="card-title">Actualizar Datos</span>
                    </div>
                    <div class="card-body">
                        <form method="POST" action="{{ route('providers.update', $provider->id) }}"  role="form" enctype="multipart/form-data">
                            {{ method_field('PATCH') }}
                            @csrf

                            @include('provider.form')

                        </form>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection

resources/views/provider/form.blade.php
<div class="box box-info padding-1">
    <div class="box-body">
        
        <div class="form-group">
            {{ Form::label('nombre') }}
            {{ Form::text('nombre', $provider->nombre, ['class' => 'form-control' . ($errors->has('nombre') ? ' is-invalid' : ''), 'placeholder' => 'Nombre']) }}
            {!! $errors->first('nombre', '<div class="invalid-feedback">:message</p>') !!}
        </div>
        <div class="form-group">
            {{ Form::label('contacto') }}
            {{ Form::text('contacto', $provider->contacto, ['class' => 'form-control' . ($errors->has('contacto') ? ' is-invalid' : ''), 'placeholder' => 'Contacto']) }}
            {!! $errors->first('contacto', '<div class="invalid-feedback">:message</p>') !!}
        </div>
        <div class="form-group">
            {{ Form::label('correo') }}
            {{ Form::text('correo', $provider->correo, ['class' => 'form-control' . ($errors->has('correo') ? ' is-invalid' : ''), 'placeholder' => 'Correo']) }}
            {!! $errors->first('correo', '<div class="invalid-feedback">:message</p>') !!}
        </div>
        <div class="form-group">
            {{ Form::label('numero', 'Número de Contacto') }}
            {{ Form::text('numero', $provider->numero, ['class' => 'form-control' . ($errors->has('numero') ? ' is-invalid' : ''), 'placeholder' => 'Numero']) }}
            {!! $errors->first('numero', '<div class="invalid-feedback">:message</p>') !!}
        </div>
        <div class="form-group">
            {{ Form::label('direccion', 'Dirección') }}
            {{ Form::text('direccion', $provider->direccion, ['class' => 'form-control' . ($errors->has('direccion') ? ' is-invalid' : ''), 'placeholder' => 'Direccion']) }}
            {!! $errors->first('direccion', '<div class="invalid-feedback">:message</p>') !!}
        </div>

    </div>
    <div class="box-footer mt20">
        <button type="submit" class="btn btn-primary">GUARDAR</button>
    </div>
</div>

resources/views/provider/index.blade.php
@extends('layouts.app')

@section('template_title')
    Proveedores
@endsection

@section('content')
    <div class="container-fluid">
        <div class="row">
            <div class="col-sm-12">
                <div class="card">
                    <div class="card-header">
                        <div style="display: flex; justify-content: space-between; align-items: center;">

                            <span id="card_title">
                                {{ __('Proveedores') }}
                            </span>

                            <div class="float-right">
                                <a href="{{ route('providers.create') }}" class="btn btn-primary btn-sm float-right"  data-placement="left">
                                    {{ __('Agregar Proveedor') }}
                                </a>
                            </div>
                        </div>
                    </div>
                    @if ($message = Session::get('success'))
                        <div class="alert alert-success">
                            <p>{{ $message }}</p>
                        </div>
                    @endif

                    <div class="card-body">
                        <div class="table-responsive">
                            <table class="table table-striped table-hover">
                                <thead class="thead">
                                    <tr>
                                        <th>No</th>
                                        
										<th>Nombre</th>
										<th>Nombre Contacto</th>
										<th>Correo Contacto</th>
										<th>Número Contacto</th>

                                        <th></th>
                                    </tr>
                                </thead>
                                <tbody>
                                    @foreach ($providers as $provider)
                                        <tr>
                                            <td>{{ $loop->index + 1 }}</td>
                                            
											<td>{{ $provider->nombre }}</td>
											<td>{{ $provider->contacto }}</td>
											<td>{{ $provider->correo }}</td>
											<td>{{ $provider->numero }}</td>

                                            <td>
                                                <form action="{{ route('providers.destroy',$provider->id) }}" method="POST">
                                                    <a class="btn btn-sm btn-primary " href="{{ route('providers.show',$provider->id) }}"><i class="fa fa-fw fa-eye"></i> Ver</a>
                                                    <a class="btn btn-sm btn-success" href="{{ route('providers.edit',$provider->id) }}"><i class="fa fa-fw fa-edit"></i> Editar</a>
                                                    @csrf
                                                    @method('DELETE')
                                                    <button type="button" class="btn btn-danger btn-sm deler"><i class="fa fa-fw fa-trash"></i> Eliminar</button>
                                                </form>
                                            </td>
                                        </tr>
                                    @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

@section('scripts')
<script>
    $(function(){
        $(".deler").click(function(){
            if(confirm("¿Desea eliminar el servicio?")){
                $(this).parent().submit();
            }
        });
    });
</script>
@endsection

resources/views/provider/show.blade.php
@extends('layouts.app')

@section('template_title')
    {{ $provider->name ?? 'Datos de Proveedor' }}
@endsection

@section('content')
    <section class="content container-fluid">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <div class="float-left">
                            <span class="card-title">Información</span>
                        </div>
                        <div class="float-right">
                            <a class="btn btn-sm btn-primary" href="{{ route('providers.index') }}"> Volver</a>
                        </div>
                    </div>

                    <div class="card-body">
                        
                        <div class="form-group">
                            <strong>Nombre:</strong>
                            {{ $provider->nombre }}
                        </div>
                        <div class="form-group">
                            <strong>Contacto:</strong>
                            {{ $provider->contacto }}
                        </div>
                        <div class="form-group">
                            <strong>Correo contacto:</strong>
                            {{ $provider->correo }}
                        </div>
                        <div class="form-group">
                            <strong>Número de Contacto:</strong>
                            {{ $provider->numero }}
                        </div>
                        <div class="form-group">
                            <strong>Dirección:</strong>
                            {{ $provider->direccion }}
                        </div>

                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection